# Задание к занятию "Дерево метаданных"

### Требования к результату

Результатом выполнения всех трех задач может быть общий файл .CF конфигурации, содержащий все, созданное в ходе выполнения задач.
Для выполнения всех трех задач, используйте базу с конфигурацией **УправлениеИТФирмой**, созданную Вами ранее

(частая ошибка: Не следует использовать конфигурацию "Курс1СРазработчик" со справочниками "Блоки", "Лекции" и т.д. Возьмите пустую конфигурацию, для которой задавали наименование, логотип и заставку, добавляйте объекты в нее. Далее мы будем развивать функционал этой конфигурации и лишние объекты могут вам мешать)

## Задача 1 "Создание справочника **Сотрудники**"

### Описание задачи

Нужно создать справочник **Сотрудники** и функциональную опцию **ВестиРасчетЗарплаты**, включив в ее состав реквизиты сотрудников, относящиеся к зарплате.

### Требования к результату

Результат - файл .CF конфигурации, содержащий справочник **Сотрудники** с реквизитами **Email**, **Телефон**, **Оклад** и **СтавкаЧаса**, и функциональную опцию, в состав которой включены реквизиты, относящиеся к расчету зарплаты.

### Процесс выполнения

1. Используйте конфигурацию **УправлениеИТФирмой**, созданную в первом задании.
2. Создайте в ней справочник **Сотрудники**.
3. Добавьте в справочник реквизиты **EMail** и **Телефон** (строки разумной длины). Подумайте, какова максимальная длина номера телефона? С учетом дополнительного номера, а также пробелов и скобок, которые может ввести пользователь?
4. Добавьте определяемый тип **Сумма** (число с двумя знаками после запятой и разумной разрядностью).
5. Добавьтье в справочник реквизиты **Оклад** и **СтавкаЧаса** определяемого типа "Сумма".
6. Добавьте булевскую константу и функциональную опцию **ВестиРасчетЗарплаты**, включив в ее состав реквизиты **Оклад** и **СтавкаЧаса**.
7. Запустите конфигурацию в режиме Предприятия, обновив конфигурацию ИБ. Удостоверьтесь, что в формах справочника "Сотрудники" скрыт оклад и ставка часа, и что они становятся видимы после включения функциональной опции (установки в Истина константы) **ВестиРасчетЗарплаты**. Константу можно изменить, например, через команду "Все функции".
8. Конфигурацию сохраните как результат выполнения задания.

## Задача 2 "Создание справочника **Контрагенты**"

### Описание задачи

Нужно создать перечисление **ЮридическоеФизическоеЛицо** и справочник **Контрагенты**, использующий его.

### Требования к результату

Результат - файл .CF конфигурации, содержащий перечисление **ЮридическоеФизическоеЛицо** и справочник **Контрагенты** с реквизитами **ПолноеНаименование**, **ЮридическийАдрес**, **ПочтовыйАдрес**, **ИНН**, **КПП** и **ЮридическоеФизическоеЛицо**.

### Процесс выполнения

1. Используйте ту же конфигурацию "УправлениеИТФирмой".
2. Создайте в ней справочник **Контрагенты**.
3. Добавьте реквизиты **ПолноеНаименование**, **ЮридическийАдрес** и **ПочтовыйАдрес** (строки разумной длины). 
4. Добавьте реквизиты **ИНН** и **КПП**. Какой длины должны быть эти строки для контрагентов-физических лиц и контрагентов-юридических лиц?
5. Добавьте перечисление **ЮридическоеФизическоеЛицо** со значениями **ЮридическоеЛицо** и **ФизическоеЛицо**.
5. Добавьте реквизит **ЮридическоеФизическоеЛицо** в справочник **Контрагенты**, использующий это перечисление.
6. Конфигурацию сохраните как результат выполнения задания.

## Задача 3 "Создание подсистемы **Справочники**"

### Описание задачи

Нужно создать подсистему **Справочники**, включающую справочники **Сотрудники** и **Контрагенты**.

### Требования к результату

Результат - файл .CF конфигурации, содержащий подсистему **Справочники** со справочниками **Контрагенты** и **Сотрудники**.

1. В конфигурации **УправлениеИТФирмой** создайте подсистему **Справочники**.
2. Дайте ей подходящую картинку.
3. Включите в нее справочники **Контрагенты** и **Сотрудники**.
4. Запустите конфигурацию в режиме Предприятия, обновив конфигурацию ИБ. Удостоверьтесь, что в командном интрфейсе есть раздел "Справочники" с командами справочников "Контрагенты" и "Сотрудники".
5. Конфигурацию сохраните как результат выполнения задания.
