# Задание к занятию "Пользователи и отладка"

## Задача 1 "Создание ролей и пользователей"

### Описание задачи
Нужно создать роли **ПолныеПрава**, **БазовыеПрава**, **ДобавлениеИзменениеКонтрагентов** и **ДобавлениеИзменениеСотрудников** и назначить их четырем пользователям.

### Требования к результату
Результат - выгрузка (.dt) информационной базы, в которой есть роли **ПолныеПрава** и **БазовыеПрава**, а также:
- пользователь **Администратор** с полными правами;
- пользователь с базовыми правами;
- пользователь с базовыми правами и правом на редактирование контрагентов;
- пользователь с базовыми правами и правом на редактирование сотрудников;

### Процесс выполнения

1. Используйте конфигурацию **УправлениеИТФирмой**.
2. Создайте в ней роль **ПолныеПрава**, включив в ней все права и предписав установку прав для новых объектов. Проще всего назначать права не отдельным объектам метаданных, с сразу их классам ("Справочники", "Документы") и т.д. Сделайте эту роль основной для конфигурации.
3. Создайте в ней роль **БазовыеПрава**, включив в ней права на просмотр и чтение всех данных конфигурации, а также право на запуск тонкого клиента и веб-клиента.
4. Создайте роли **ДобавлениеИзменениеСотрудников** и **ДобавлениеИзменениеКонтрагентов**, дающие права на интерактивное добавление и редактирование контрагентов и сотрудников.
5. Создайте пользователей ИБ:
- **Администратор** с ролью **ПолныеПрава**;
- произвольного пользователя с ролью **БазовыеПрава**; 
- пользователя с ролями **БазовыеПрава** и **ДобавлениеИзменениеКонтрагентов**; 
- пользователя с ролями **БазовыеПрава** и **ДобавлениеИзменениеСотрудников**. 
6. Обновите конфигурацию БД и запустите конфигурацию в режиме Предприятия подо всеми четырьмя пользователями. Убедитесь, что администратор может редактировать, что угодно; пользователь с базовыми правами может только просматривать данные; а два пользователя с ролью "ДобавлениеИзменение..." могут редактировать данные одного вида, и только просматривать все остальные.
7. Выгрузите ИБ в .dt как результат выполнения задания.

## Задача 2 "Поиск ошибки с помощью точки останова"

### Описание задачи
Нужно найти в учебной демобазе и исправить специально привнесенную ошибку с помощью остановки по ошибке.

### Требования к результату
Результат - файл .CF конфигурации, в котором исправлена ошибка, возникавшая при попытке записать блок.

### Процесс выполнения
1. Создайте пустую ИБ и загрузите в нее демо-базу (https://github.com/netology-code/1c-homeworks/blob/master/1c-developer-demo.dt).
2. Запустите ее в режиме Предприятия с отладкой и воспроизведите ошибку, открыв любой блок из списка и попытавшись записать его.
3. Найдите строку с ошибкой с помощью функции "Остановка по ошибке" и исправьте ее.
4. Сохраните конфигурацию как результат выполнения задания.

## Задача 3 "Поиск ошибки с помощью журнала регистрации"

### Описание задачи
Нужно найти в учебной демобазе и исправить специально привнесенную ошибку с помощью журнала регистрации.

### Требования к результату
Результат - файл .CF конфигурации, в котором исправлена ошибка, возникавшая при работе фонового задания.

### Процесс выполнения
1. Создайте пустую ИБ и загрузите в нее демо-базу (https://github.com/netology-code/1c-homeworks/blob/master/1c-developer-demo.dt).
2. Запустите ее в режиме Предприятия с отладкой и найдите в журнале регистрации ошибки работы фонового задания.
3. Найдите в конфигурации строку с этой ошибкой и исправьте ее.
4. Убедитесь, снова запустив конфигурацию в режиме "Предприятия", что ошибка перестала воспроизводиться.
5. Сохраните конфигурацию как результат выполнения задания.
