# Интерфейс конфигурации

## Задание 1

### Описание задачи

Создайте конфигурацию с требуемыми настройками интерфейса.

### Требование к результату

Конфигурация "Управление ИТ-фирмой", имеющая в своем составе все нужные объекты метаданных и интерфейс, позволяющий выполнять навигацию по данным.
Конфигурация должна соответствовать требованиям:

* При запуске конфигурации панель навигации по разделам должна располагаться слева. Открытые окна - сверху, как в браузере Chrome.
* В разделе "Закупки" на самом видном месте должны быть расположены документы "Заказ поставщику" и справочник "Контрагенты".
* В разделе "Закупки" должен быть выделен отдельно подраздел "Складской учет" содержащий справочник "Склады" и отчет "Остатки по складам" Логику отчета реализовывать не надо.
* Раздел "Продажи" на самом видном месте должен содержать пункт "Заказы покупателей"
* Раздел отчетность должен содержать отчеты "Остатки по складам" и "Отчет по продажам"
* Сразу при старте приложения должен отображаться список документов "Заказы покупателей".

### Процесс выполнения

В созданной ранее конфигурации "Управление ИТ-фирмой", заведите 3 подсистемы:

* Закупки
* Продажи
* Отчетность

Создайте все объекты метаданных, описанные в разделе "Требование к результату":

* 2 документа
* 2 справочника
* 2 отчета

При создании документов, добавьте им основные формы списков и формы объектов.
При создании отчетов, добавьте им основную форму или схему компоновки данных. Это необходимо, чтобы отчет появился в меню командного интерфейса.

## Задание 2

### Описание задачи

Развитие конфигурации "Управление ИТ-фирмой", добавление общих функций, улучшение юзабилити подписей.

### Требование к результату

Обеспечьте следующие требования к интерфейсу:

* Все формы списков должны отображать представление во множественном числе, а формы объектов - в единственном. "Заказы покупателей" -> "Заказ покупателя" и т.п.
* Все документы конфигурации должны иметь кнопку "Печать" в формах списков и объектов. Нажатие на кнопку печать должно показывать предупреждение "Демо-версия. Печать будет реализована позднее". Окно предупреждения должно иметь заголовок "Мы работаем над этим..."

### Процесс выполнения

1. Добавьте общую команду "Печать". В качестве типа параметра команды укажите документы "Заказ поставщику" и "Заказ покупателю". Добавьте команду в группу "Командная панель формы: Важное"
2. Напишите процедуру ОбработкаКоманды для команды "Печать" в соответствии с требованиями
3. Задайте правильное представление объекта и представление списка для всех справочников и документов конфигурации. 

# Задание 3

### Описание задачи

На главной странице приложения требуется отображать сразу 2 формы: список заказов поставщикам и список заказов покупателям. Также, требуется добавить команду быстрой отправки заказа поставщику по электронной почте и быстрого создания документа "Заказ поставщику".

### Требование к результату

На главной странице приложения отображаются два списка, один под другим, документов "Заказ поставщику" и "Заказ покупателя". В документе "Заказ поставщику" создана команда "Отправить заказ". При нажатии на кнопку должно выдаваться предупреждение "Демо-версия. Данная возможность не реализована". В командах раздела "Продажи" видна команда "Создать" для документа "Заказ покупателя".

### Порядок выполнения

1. Возьмите конфигурацию из заданий 1 и 2. Сохраните ее отдельно и на основании нее создайте новую, так, чтобы результатом заданий 1 и 2 был один файл, а результатом задания 3 - другой файл.
2. Откройте рабочую область начальной страницы. Разместите в одной колонке 2 формы списка: документов "заказы покупателей" и "заказы поставщикам"
3. Откройте командный интерфейс раздела "Продажи". Установите флажок "Видимость" у команды "Заказ покупателя: Создать"
4. Добавьте в документ "Заказ поставщику" команду "Отправить заказ". Реализуйте процедуру "ОбработкаКоманды" согласно требованиям. Добавьте команду в группу "Командная панель формы: Важное"
