# Задание к занятию "Документы"

## Задача 1 документ "Событие"

### Описание задачи

Создать документ "Событие" для хранения данных о планируемых действиях.

Документ оформляется при взаимодействии с контрагентом. Например, при звонке. Содержит информацию о сути взаимодействия.

### Требования к результату

Выгрузка информационной базы (.dt). Документ должен содержать следующие поля:

* "Контрагент" - на форме документа поле выбора Контрагента
* "Ответственный" - При создании объекта заполняется по умолчанию текущим пользователем.
* "Тип событий" - Можно выбрать одно из доступных значений.
* "Содержание" - на форме документа поле ввода многострочное.


Все реквизиты присутствуют на форме и доступны для редактирования. Все реквизиты обязательны для заполнения.

### Процесс выполнения

Добавить Перечисление ТипыСобытий.

Значения:
- Звонок
- Встреча
- Письмо

* Добавить документ "Событие" с реквизитами
  * Тип (ПеречислениеСсылка.ТипыСобытий)
  * Ответственный (СправочникСсылка.Сотрудники)
  * Содержание (Строка 200)
  * Контрагент (СправочникСсылка.Контрагент).
* Добавить каждый реквизит на форму документа. В поле ввода "Содержание" поставить флажок "МногострочныйРежим".

## Задача 2 добавить форму выбора и списка в документ "Событие" 

### Описание задачи

* Создать форму списка.
* Создать форму выбора.

В справочники Контрагенты
добавить Команду "События" на форму документа

### Требования к результату

Выгрузка информационной базы (.dt). Из подсистемы "Сделки" есть возможность открытия документа "Событие".

При нажатии на форме элемента Контрагенты на "События" открывать форму списка документов "Событие" с отбором по контрагенту

### Процесс выполнения

* Добавить подсистему "Сделки".
* Открыть окно свойств документа Событие.
* Добавить форму списка - Далее - выделить все доступные реквизиты (поставить галочки на Дата, ТипСобытий, Ответственный, Содержание) - Готово.
* Повторить для формы выбора.
* Добавить в подсистему "Сделки" документ Событие.

В окне конфигурации выделить документ "Событие" - правой кнопкой мыши клик - Дополнительно.
Откроется окно выбора подсистемы - поставить галочку на "Сделки".

В справочники Контрагенты на форму элемента добавить команду "Событие"
В процедуре добавить вызов формы списка документа "Событие" с отбором на текущем контрагенте

```bsl
ЗначениеОтбора = Новый Структура("Контрагент", Объект.Ссылка);
ПараметрыФормы = Новый Структура("Отбор", ЗначениеОтбора);
ОткрытьФорму("Документ.Событие.ФормаСписка", ПараметрыФормы,, Объект.Ссылка); // Уникальность - Контрагент
```

Обновить конфигурацию.
