# Задание к занятию "Проведение и движения"

## Задача 1 Добавить движения в Документы "Поступление товаров и услуг" и "Реализация товаров и услуг"

### Описание задачи

Проведение документов "Поступление товаров и услуг" и "Реализация товаров и услуг" добавляет движения товаров по регистру накопления "Товары"

### Требования к результату

Выгрузка информационной базы (.dt). Документы "Поступление товаров и услуг" и "Реализация товаров и услуг" должны добавлять приход и расход по регистру накопления "Товары",

иметь одинаковую структуру движения по реквизитам, измерениям, ресурсам.

Отличие - только в направлении движения (приход и расход)

Движения должны содержать следующие данные:

* "Дата"
* "Номенклатура"
* "Количество"

### Процесс выполнения

1. Добавить регистр накопления "Товары":

измерения:
- Номенклатура (СправочникСсылка.Номенклатура)

ресурсы:
- Количество (ОпределяемыйТип.Количество)

Регистраторы - установить галочки на "Поступление товаров и услуг" и "Реализация товаров и услуг" 

Вид регистра - Остатки

2. Открыть документ Поступления - закладка Движения - Конструктор движений

Создать движение - приход по РН Товары

Движение.Период = Дата;
Движение.ВидДвижения = ВидДвиженияНакопления.Приход
Остальное заполняем  из ТЧ "Товары"

3. Повторить по аналогии для документа "Реализация товаров и услуг"

отличие:
Движение.ВидДвижения = ВидДвиженияНакопления.Расход

## Задача 2 добавить движение для документа "Установка цен" 

### Описание задачи

Добавить в документы "Установка цен" движение по регистру сведений "Цены"

### Требования к результату

Выгрузка информационной базы (.dt). Документ "Установка цен" формирует движения по регистру сведений "Цены"

### Процесс выполнения

0. Добавить документ УстановкаЦен ("Установка цен") с табличной частью Цены с реквизитами:

- Номенклатура
- Цена

1. Очистить все записи из регистра сведений "Цены", затем донастроить его:

периодичность - В пределах секунды

режим записи - Подчинение регистратору

измерения:
- Номенклатура (СправочникСсылка.Номенклатура)
ресурсы:
- Цена (Число 10)

2. Открыть документ "Установка цен" - закладка Движения - Конструктор движений

Создать движение - по РС Цены

```bsl
Движения.Цены.Записывать = Истина;
	Для Каждого ТекСтрокаТовары Из Цены Цикл
		Движение = Движения.Цены.Добавить();
		Движение.Период = Дата;
		Движение.Номенклатура = ТекСтрокаТовары.Номенклатура;
		Движение.Цена = ТекСтрокаТовары.Цена;
	КонецЦикла;
```
